//
//  View.m
//  Torch
//
//  Created by NYU User on 11/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"


@implementation View


- (id) initWithFrame: (CGRect) frame {
    if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];


		layer = [[CALayer alloc] init];
		UIImage *image = [UIImage imageNamed: @"torch.png"];
		layer.contents = (id)image.CGImage;

		//Center the layer in the view.
		CGRect b = self.bounds;
		layer.frame = CGRectMake(
			b.origin.x + (b.size.width - image.size.width) / 2,
			b.origin.y + (b.size.height - image.size.height) / 2,
			image.size.width,
			image.size.height
		);
		
		[self.layer addSublayer: layer];
	}
    return self;
}

- (void) touchesBegan: (NSSet *) touches withEvent: (UIEvent *) event {
/*
	CABasicAnimation *animation =
		[CABasicAnimation animationWithKeyPath: @"opacity"];
	
	animation.fromValue = [NSNumber numberWithFloat: 0.0];
	animation.toValue = [NSNumber numberWithFloat: 1.0];
	animation.duration = 2.0;
	animation.timingFunction =
		[CAMediaTimingFunction functionWithName:
		kCAMediaTimingFunctionEaseInEaseOut];

	[layer addAnimation: animation forKey: @"opacityAnimation"];
*/
	CAKeyframeAnimation *animation =
		[CAKeyframeAnimation animationWithKeyPath: @"transform"];
	
	CGFloat theta = 2 * M_PI / 180;	//angle of rotation, in radians

	animation.values = [NSArray arrayWithObjects:
		//5 degrees counterclockwise
		[NSValue valueWithCATransform3D:
			CATransform3DMakeRotation(-theta, 0, 0, 1)],

		//10 degrees clockwise
		[NSValue valueWithCATransform3D:
			CATransform3DMakeRotation(2 * theta, 0, 0, 1)],
					   
		//back to initial orientation
		[NSValue valueWithCATransform3D:
			CATransform3DMakeRotation(-theta, 0, 0, 1)],

		nil
	];
	
	animation.duration = .175;			//seconds
	animation.repeatCount = HUGE_VALF;	//repeat forever
	animation.calculationMode = kCAAnimationCubic;
	[layer addAnimation: animation forKey: @"jiggleAnimation"];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (void) dealloc {
	[layer removeFromSuperlayer];
	[layer release];
	[super dealloc];
}


@end
